
var style_sort_order = {    "ER" : 0,
                            "SR" : 1,
                            "MR" : 2,
                            "DR" : 3 };

// Conversions:
var GAL_1000_TO_GAL_ACRE = 43.56;       // 1 US Gal/1000 sq ft to US Gal/Acre      http://www.wolframalpha.com/input/?i=1+US+Gal%2F1000+sq+ft+to+1+US+Gal%2FAcre
var IMP_GAL_ACRE_TO_GAL_ACRE = 1.201    // Imp Gal/Acre to US Gal/Acre             http://www.wolframalpha.com/input/?i=Imp+Gal%2FAcre+to+US+Gal%2FAcre
var LITRES_HECTARE_TO_GAL_ACRE = 0.1069 // Litres/Hectare to US Gal/Acre           http://www.wolframalpha.com/input/?i=Litres%2FHectare+to+US+Gal%2FAcre

var PSI_TO_BAR = 0.0689475729;
var MPH_TO_KMH = 1.60934;
var INCHES_TO_CM = 2.540;

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

function showTargetApplicationRate ($scope, $ionicActionSheet, rate_conv, rate_units) {

    values = [];
    if ($scope.wilgerservice.application_unit == 'gp1k') {
        values = [0.1,0.2,0.3,0.4,0.5,0.6];
    } else if ($scope.wilgerservice.application_unit == 'igpa') {
        values = [5,7.5,10,12.5,15,20];
    } else if ($scope.wilgerservice.application_unit == 'lph') {
        values = [50,75,100,125,150,175];
    } else {
        values = [5,7.5,10,12.5,15,20];
    }

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
     buttons: [
         { text: values[0] + ' ' + rate_units },
         { text: values[1] + ' ' + rate_units },
         { text: values[2] + ' ' + rate_units },
         { text: values[3] + ' ' + rate_units },
         { text: values[4] + ' ' + rate_units },
         { text: values[5] + ' ' + rate_units }
     ],
     titleText: 'Select Target Application Rate (' + rate_units + ')',
     cancelText: 'Cancel',
     cancel: function() {
          // add cancel code.
     },
     buttonClicked: function(index) {

        switch (index) {
            case 0: $scope.wilgerservice.target_application_rate = values[0];   break;
            case 1: $scope.wilgerservice.target_application_rate = values[1];   break;
            case 2: $scope.wilgerservice.target_application_rate = values[2];   break;
            case 3: $scope.wilgerservice.target_application_rate = values[3];   break;
            case 4: $scope.wilgerservice.target_application_rate = values[4];   break;
            case 5: $scope.wilgerservice.target_application_rate = values[5];   break;
        }

       return true;
     }
    });
}

function showTargetApplicationRate2 ($scope, $ionicActionSheet, rate_conv, rate_units) {

    values = [];
    if ($scope.wilgerservice.application_unit == 'gp1k') {
        values = [0.1,0.2,0.3,0.4,0.5,0.6];
    } else if ($scope.wilgerservice.application_unit == 'igpa') {
        values = [5,7.5,10,12.5,15,20];
    } else if ($scope.wilgerservice.application_unit == 'lph') {
        values = [50,75,100,125,150,175];
    } else {
        values = [5,7.5,10,12.5,15,20];
    }

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
     buttons: [
         { text: values[0] + ' ' + rate_units },
         { text: values[1] + ' ' + rate_units },
         { text: values[2] + ' ' + rate_units },
         { text: values[3] + ' ' + rate_units },
         { text: values[4] + ' ' + rate_units },
         { text: values[5] + ' ' + rate_units }
     ],
     titleText: 'Select Target Application Rate (' + rate_units + ')',
     cancelText: 'Cancel',
     cancel: function() {
          // add cancel code..
     },
     buttonClicked: function(index) {

        switch (index) {
            case 0: $scope.wilgerservice.target_application_rate_2 = values[0];   break;
            case 1: $scope.wilgerservice.target_application_rate_2 = values[1];   break;
            case 2: $scope.wilgerservice.target_application_rate_2 = values[2];   break;
            case 3: $scope.wilgerservice.target_application_rate_2 = values[3];   break;
            case 4: $scope.wilgerservice.target_application_rate_2 = values[4];   break;
            case 5: $scope.wilgerservice.target_application_rate_2 = values[5];   break;
        }

       return true;
     }
    });
}

function showAverageSprayerSpeed ($scope, $ionicActionSheet, speed_conv, speed_units) {

    values = [];
    if ($scope.wilgerservice.application_unit == 'gp1k') {
        values = [5,7.5,10,12.5,15,17.5,20];
    } else if ($scope.wilgerservice.application_unit == 'igpa') {
        values = [5,7.5,10,12.5,15,17.5,20];
    } else if ($scope.wilgerservice.application_unit == 'lph') {
        values = [5,10,15,20,25,30,35];
    } else {
        values = [5,7.5,10,12.5,15,17.5,20];
    }

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
          { text: values[0] + ' ' + speed_units },
          { text: values[1] + ' ' + speed_units },
          { text: values[2] + ' ' + speed_units },
          { text: values[3] + ' ' + speed_units },
          { text: values[4] + ' ' + speed_units },
          { text: values[5] + ' ' + speed_units },
          { text: values[6] + ' ' + speed_units }
      ],
      titleText: 'Select Target Average Sprayer Speed ('+speed_units+')',
      cancelText: 'Cancel',
      cancel: function() {
           // add cancel code..
      },
      buttonClicked: function(index) {

         switch (index) {
             case 0: $scope.wilgerservice.target_average_sprayer_speed = values[0]; break;
             case 1: $scope.wilgerservice.target_average_sprayer_speed = values[1]; break;
             case 2: $scope.wilgerservice.target_average_sprayer_speed = values[2]; break;
             case 3: $scope.wilgerservice.target_average_sprayer_speed = values[3]; break;
             case 4: $scope.wilgerservice.target_average_sprayer_speed = values[4]; break;
             case 5: $scope.wilgerservice.target_average_sprayer_speed = values[5]; break;
             case 6: $scope.wilgerservice.target_average_sprayer_speed = values[6]; break;
         }

        return true;
      }
    });

}

function showMaxSprayerSpeed ($scope, $ionicActionSheet, speed_conv, speed_units) {
    values = [];
    if ($scope.wilgerservice.application_unit == 'gp1k') {
        values = [5,7.5,10,12.5,15,17.5,20];
    } else if ($scope.wilgerservice.application_unit == 'igpa') {
        values = [5,7.5,10,12.5,15,17.5,20];
    } else if ($scope.wilgerservice.application_unit == 'lph') {
        values = [5,10,15,20,25,30,35];
    } else {
        values = [5,7.5,10,12.5,15,17.5,20];
    }

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
          { text: values[0] + ' ' + speed_units },
          { text: values[1] + ' ' + speed_units },
          { text: values[2] + ' ' + speed_units },
          { text: values[3] + ' ' + speed_units },
          { text: values[4] + ' ' + speed_units },
          { text: values[5] + ' ' + speed_units },
          { text: values[6] + ' ' + speed_units }
      ],
      titleText: 'Select Max Sprayer Speed ('+speed_units+')',
      cancelText: 'Cancel',
      cancel: function() {
           // add cancel code..
      },
      buttonClicked: function(index) {

         switch (index) {
             case 0: $scope.wilgerservice.target_max_sprayer_speed = values[0]; break;
             case 1: $scope.wilgerservice.target_max_sprayer_speed = values[1]; break;
             case 2: $scope.wilgerservice.target_max_sprayer_speed = values[2]; break;
             case 3: $scope.wilgerservice.target_max_sprayer_speed = values[3]; break;
             case 4: $scope.wilgerservice.target_max_sprayer_speed = values[4]; break;
             case 5: $scope.wilgerservice.target_max_sprayer_speed = values[5]; break;
             case 6: $scope.wilgerservice.target_max_sprayer_speed = values[6]; break;
         }

        return true;
      }
    });

}

function showNozzleSpacing ($scope, $ionicActionSheet, length_conv, length_units) {
    values = [];
    if ($scope.wilgerservice.application_unit == 'gp1k') {
        values = [5,7.5,10,12.5,15,17.5,20,25];
    } else if ($scope.wilgerservice.application_unit == 'igpa') {
        values = [5,7.5,10,12.5,15,17.5,20,25];
    } else if ($scope.wilgerservice.application_unit == 'lph') {
        values = [35,40,45,50,55,60,65,70];
    } else {
        values = [5,7.5,10,12.5,15,17.5,20,25];
    }

    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
          { text: values[0] + ' ' + length_units },
          { text: values[1] + ' ' + length_units },
          { text: values[2] + ' ' + length_units },
          { text: values[3] + ' ' + length_units },
          { text: values[4] + ' ' + length_units },
          { text: values[5] + ' ' + length_units },
          { text: values[6] + ' ' + length_units },
          { text: values[7] + ' ' + length_units }
      ],
      titleText: 'Select Nozzle Spacing ('+length_units+')',
      cancelText: 'Cancel',
      cancel: function() {
           // add cancel code..
      },
      buttonClicked: function(index) {

         switch (index) {
             case 0: $scope.wilgerservice.nozzle_spacing = values[0];   break;
             case 1: $scope.wilgerservice.nozzle_spacing = values[1];   break;
             case 2: $scope.wilgerservice.nozzle_spacing = values[2];   break;
             case 3: $scope.wilgerservice.nozzle_spacing = values[3];   break;
             case 4: $scope.wilgerservice.nozzle_spacing = values[4];   break;
             case 5: $scope.wilgerservice.nozzle_spacing = values[5];   break;
             case 6: $scope.wilgerservice.nozzle_spacing = values[6];   break;
             case 7: $scope.wilgerservice.nozzle_spacing = values[7];   break;
         }

        return true;
      }
    });
}

function showTargetDropletSize ($scope, $ionicActionSheet) {
    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: [
        { text: 'None' },
        { text: '150' },
        { text: '200' },
        { text: '250' },
        { text: '300' },
        { text: '350' },
        { text: '400' },
        { text: '450' },
        { text: '500' }
      ],
      titleText: 'Select Target Droplet Size',
      cancelText: 'Cancel',
      cancel: function() {
           // add cancel code..
      },
      buttonClicked: function(index) {

         switch (index) {
             case 0: $scope.wilgerservice.target_droplet_size = 0;    break;
             case 1: $scope.wilgerservice.target_droplet_size = 150;   break;
             case 2: $scope.wilgerservice.target_droplet_size = 200;   break;
             case 3: $scope.wilgerservice.target_droplet_size = 250;   break;
             case 4: $scope.wilgerservice.target_droplet_size = 300;   break;
             case 5: $scope.wilgerservice.target_droplet_size = 350;   break;
             case 6: $scope.wilgerservice.target_droplet_size = 400;   break;
             case 7: $scope.wilgerservice.target_droplet_size = 450;   break;
             case 8: $scope.wilgerservice.target_droplet_size = 500;   break;
         }

        return true;
      }
    });
}

function switchUnits ($scope) {

    if ($scope.wilgerservice.application_unit == 'gp1k') {
        $scope.wilgerservice.display_units_string_rate = "US Gal/1000 sq ft.";
        $scope.wilgerservice.display_units_string_rate_short_1 = "(usgal/";
        $scope.wilgerservice.display_units_string_rate_short_2 = "1000ft^2)";
        $scope.wilgerservice.display_units_conv_rate = 1.0/GAL_1000_TO_GAL_ACRE;

        $scope.wilgerservice.display_units_string_press = "psi";
        $scope.wilgerservice.display_units_conv_press = 1.0;
        $scope.wilgerservice.display_units_decimals_press = 0;

        $scope.wilgerservice.display_units_string_speed = "mph";
        $scope.wilgerservice.display_units_conv_speed = 1.0;

        $scope.wilgerservice.display_units_string_length = "in";
        $scope.wilgerservice.display_units_conv_length = 1.0;

    } else if ($scope.wilgerservice.application_unit == 'igpa') {
        $scope.wilgerservice.display_units_string_rate = "Imp Gal/Acre";
        $scope.wilgerservice.display_units_string_rate_short_1 = "(impgal/";
        $scope.wilgerservice.display_units_string_rate_short_2 = "Acre)";
        $scope.wilgerservice.display_units_conv_rate = 1.0/IMP_GAL_ACRE_TO_GAL_ACRE;

        $scope.wilgerservice.display_units_string_press = "psi";
        $scope.wilgerservice.display_units_conv_press = 1.0;
        $scope.wilgerservice.display_units_decimals_press = 0;

        $scope.wilgerservice.display_units_string_speed = "mph";
        $scope.wilgerservice.display_units_conv_speed = 1.0;

        $scope.wilgerservice.display_units_string_length = "in";
        $scope.wilgerservice.display_units_conv_length = 1.0;

    } else if ($scope.wilgerservice.application_unit == 'lph') {
        $scope.wilgerservice.display_units_string_rate = "Litres/Hectare";
        $scope.wilgerservice.display_units_string_rate_short_1 = "(l/ha)";
        $scope.wilgerservice.display_units_string_rate_short_2 = "";
        $scope.wilgerservice.display_units_conv_rate = 1.0/LITRES_HECTARE_TO_GAL_ACRE;

        $scope.wilgerservice.display_units_string_press = "bar";
        $scope.wilgerservice.display_units_conv_press = PSI_TO_BAR;
        $scope.wilgerservice.display_units_decimals_press = 1;

        $scope.wilgerservice.display_units_string_speed = "km/h";
        $scope.wilgerservice.display_units_conv_speed = MPH_TO_KMH;

        $scope.wilgerservice.display_units_string_length = "cm";
        $scope.wilgerservice.display_units_conv_length = INCHES_TO_CM;

    } else {
        $scope.wilgerservice.display_units_string_rate = "US Gal/Acre";
        $scope.wilgerservice.display_units_string_rate_short_1 = "(usgal/";
        $scope.wilgerservice.display_units_string_rate_short_2 = "Acre)";
        $scope.wilgerservice.display_units_conv_rate = 1.0;

        $scope.wilgerservice.display_units_string_press = "psi";
        $scope.wilgerservice.display_units_conv_press = 1.0;
        $scope.wilgerservice.display_units_decimals_press = 0;

        $scope.wilgerservice.display_units_string_speed = "mph";
        $scope.wilgerservice.display_units_conv_speed = 1.0;

        $scope.wilgerservice.display_units_string_length = "in";
        $scope.wilgerservice.display_units_conv_length = 1.0;
    }

}

function switchUnitsFert ($scope) {

    if ($scope.wilgerservice.fert_application_unit == 'gp1k') {
        $scope.wilgerservice.fert_display_units_string_rate = "US Gal/1000 sq ft.";
        $scope.wilgerservice.fert_display_units_string_rate_short_1 = "usgal/";
        $scope.wilgerservice.fert_display_units_string_rate_short_2 = "1000ft^2";
        $scope.wilgerservice.fert_display_units_conv_rate = 1.0/GAL_1000_TO_GAL_ACRE;

        $scope.wilgerservice.fert_display_units_string_press = "psi";
        $scope.wilgerservice.fert_display_units_conv_press = 1.0;
        $scope.wilgerservice.fert_display_units_decimals_press = 0;

        $scope.wilgerservice.fert_display_units_string_speed = "mph";
        $scope.wilgerservice.fert_display_units_conv_speed = 1.0;

        $scope.wilgerservice.fert_display_units_string_length = "in";
        $scope.wilgerservice.fert_display_units_conv_length = 1.0;

    } else if ($scope.wilgerservice.fert_application_unit == 'igpa') {
        $scope.wilgerservice.fert_display_units_string_rate = "Imp Gal/Acre";
        $scope.wilgerservice.fert_display_units_string_rate_short_1 = "impgal/";
        $scope.wilgerservice.fert_display_units_string_rate_short_2 = "Acre";
        $scope.wilgerservice.fert_display_units_conv_rate = 1.0/IMP_GAL_ACRE_TO_GAL_ACRE;

        $scope.wilgerservice.fert_display_units_string_press = "psi";
        $scope.wilgerservice.fert_display_units_conv_press = 1.0;
        $scope.wilgerservice.fert_display_units_decimals_press = 0;

        $scope.wilgerservice.fert_display_units_string_speed = "mph";
        $scope.wilgerservice.fert_display_units_conv_speed = 1.0;

        $scope.wilgerservice.fert_display_units_string_length = "in";
        $scope.wilgerservice.fert_display_units_conv_length = 1.0;

    } else if ($scope.wilgerservice.fert_application_unit == 'lph') {
        $scope.wilgerservice.fert_display_units_string_rate = "Litres/Hectare";
        $scope.wilgerservice.fert_display_units_string_rate_short_1 = "l/ha";
        $scope.wilgerservice.fert_display_units_string_rate_short_2 = "";
        $scope.wilgerservice.fert_display_units_conv_rate = 1.0/LITRES_HECTARE_TO_GAL_ACRE;

        $scope.wilgerservice.fert_display_units_string_press = "bar";
        $scope.wilgerservice.fert_display_units_conv_press = PSI_TO_BAR;
        $scope.wilgerservice.fert_display_units_decimals_press = 1;

        $scope.wilgerservice.fert_display_units_string_speed = "km/h";
        $scope.wilgerservice.fert_display_units_conv_speed = MPH_TO_KMH;

        $scope.wilgerservice.fert_display_units_string_length = "cm";
        $scope.wilgerservice.fert_display_units_conv_length = INCHES_TO_CM;

    } else {
        $scope.wilgerservice.fert_display_units_string_rate = "US Gal/Acre";
        $scope.wilgerservice.fert_display_units_string_rate_short_1 = "usgal/";
        $scope.wilgerservice.fert_display_units_string_rate_short_2 = "Acre";
        $scope.wilgerservice.fert_display_units_conv_rate = 1.0;

        $scope.wilgerservice.fert_display_units_string_press = "psi";
        $scope.wilgerservice.fert_display_units_conv_press = 1.0;
        $scope.wilgerservice.fert_display_units_decimals_press = 0;

        $scope.wilgerservice.fert_display_units_string_speed = "mph";
        $scope.wilgerservice.fert_display_units_conv_speed = 1.0;

        $scope.wilgerservice.fert_display_units_string_length = "in";
        $scope.wilgerservice.fert_display_units_conv_length = 1.0;
    }

}

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

angular.module('wilger.controllers', [])

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.run(function(WilgerService) {


})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardMainCtrl', function($scope, $state, $ionicActionSheet, $ionicPopover, WilgerService) {
    $scope.wilgerservice = WilgerService;

    //
    // Radio button groups
    //

    $scope.application_unit_list = [
        { text: "US Gal/Acre", value: "gpa" },
        { text: "US Gal/1000 sq ft.", value: "gp1k" },
        { text: "Imp Gal/Acre", value: "igpa" },
        { text: "Litres/Hectare", value: "lph" }
    ];

    $scope.onChangeUnit = function (val) {
        switchUnits($scope);
    }

    $scope.spray_system_list = [
        { text: "Standard Spray System", value: "sss" },
        { text: "Pulse Width Modulation", value: "pwm" },
    ];

    $scope.search_function_list = [
        { text: "Search For Spray Tips", value: "search_spray" },
        { text: "Specific Tip Look-Up", value: "search_specific" },
        { text: "Favorites", value: "search_favorites" },
    ];

    //
    // Button actions
    //

    // function to open the modal
    $scope.continuePressed = function () {

        switchUnits ($scope);

        // Function
        if ($scope.wilgerservice.search_function == 'search_specific') {
            if ($scope.wilgerservice.spray_system == 'sss') {
                $state.go('tab.specific-standard');
            } else {
                $state.go('tab.specific-pulsed');
            }

        } else if ($scope.wilgerservice.search_function == 'search_favorites') {
            if ($scope.wilgerservice.spray_system == 'sss') {
                $state.go('tab.favorites-standard');
            } else {
                $state.go('tab.favorites-pulsed');
            }

        } else {
            if ($scope.wilgerservice.spray_system == 'sss') {
                $state.go('tab.calc-standard');
            } else {
                $state.go('tab.calc-pulsed');
            }
        }

    };


    // Popups
    // $ionicPopover.fromTemplateUrl('templates/info_application_unit.html', {
    //     scope: $scope
    // }).then(function(popover) {
    //     $scope.info_application_unit_popover = popover;
    // });
    //
    // $scope.info_application_unit = function ($event) {
    //     $scope.info_application_unit_popover.show($event);
    // };


    $ionicPopover.fromTemplateUrl('templates/info_search_function.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_search_function_popover = popover;
    });

    $scope.info_search_function = function ($event) {
        $scope.info_search_function_popover.show($event);
    };


    $ionicPopover.fromTemplateUrl('templates/info_spray_system.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_spray_system_popover = popover;
    });

    $scope.info_spray_system = function ($event) {
        $scope.info_spray_system_popover.show($event);
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardCalcStandardCtrl', function($scope, $state, $ionicActionSheet, $ionicPopover, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.calculatePressed = function () {

        //
        // Calculate results
        //

        var A = $scope.wilgerservice.target_application_rate * 1.0/$scope.wilgerservice.display_units_conv_rate;
        var S = $scope.wilgerservice.target_average_sprayer_speed * 1.0/$scope.wilgerservice.display_units_conv_speed;
        var N = $scope.wilgerservice.nozzle_spacing * 1.0/$scope.wilgerservice.display_units_conv_length;
        var An = $scope.wilgerservice.tip_angle == '80' ? 80 : 110;
        var T = $scope.wilgerservice.target_droplet_size;

        // See if we can update
        if (!A || !S || !N || !An) {
            $scope.wilgerservice.best_results = [];
            $scope.wilgerservice.other_results = [];
            return; // Early out
        }

        var results = get_standard_tips(A, S, N, An, T);

        $scope.wilgerservice.best_results = results[0];
        $scope.wilgerservice.other_results = results[1];

        // Build charts
        build_charts_standard($scope.wilgerservice.best_results, A, S, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_decimals_press);
        build_charts_standard($scope.wilgerservice.other_results, A, S, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_decimals_press);

        $state.go('tab.calc-standard-results');

        $scope.wilgerservice.save();
    };

    $scope.calculateDisabled = function () {
        var A = $scope.wilgerservice.target_application_rate;
        var S = $scope.wilgerservice.target_average_sprayer_speed;
        var N = $scope.wilgerservice.nozzle_spacing;
        var An = $scope.wilgerservice.tip_angle == '80' ? 80 : 110;
        var T = $scope.wilgerservice.target_droplet_size;

        if (A>0 && S>0 && N>0) {
            return false;
        } else {
            return true;
        }

    }

    //
    // Radio button groups
    //

    $scope.tip_angle_list = [
        { text: "80°", value: "80" },
        { text: "110°", value: "110" },
    ];

    //
    // Action sheets
    //

    $scope.showTargetApplicationRate = function() {
        showTargetApplicationRate($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_string_rate);
    };


    $scope.showAverageSprayerSpeed = function() {
        showAverageSprayerSpeed($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_string_speed);
    };


    $scope.showNozzleSpacing = function() {
        showNozzleSpacing($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_length, $scope.wilgerservice.display_units_string_length);
    };


    $scope.showTargetDropletSize = function() {
        showTargetDropletSize($scope, $ionicActionSheet);
    };

    // Popups
    $ionicPopover.fromTemplateUrl('templates/info_droplet_size_standard.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_droplet_size_popover = popover;
    });

    $scope.info_droplet_size = function ($event) {
        $scope.info_droplet_size_popover.show($event);
    };

})


.controller('WizardCalcPulsedCtrl', function($scope, $state, $ionicActionSheet, $ionicPopover, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.calculatePressed = function () {

        //
        // Calculate results
        //

        var A = $scope.wilgerservice.target_application_rate * 1.0/$scope.wilgerservice.display_units_conv_rate;
        var S = $scope.wilgerservice.target_max_sprayer_speed * 1.0/$scope.wilgerservice.display_units_conv_speed;
        var N = $scope.wilgerservice.nozzle_spacing * 1.0/$scope.wilgerservice.display_units_conv_length;
        var An = $scope.wilgerservice.tip_angle == '80' ? 80 : 110;
        var T = $scope.wilgerservice.target_droplet_size;

        // See if we can update
        if (!A || !S || !N || !An) {
            $scope.wilgerservice.best_results = [];
            $scope.wilgerservice.other_results = [];
            return; // Early out
        }

        var results = get_pulsed_tips(A, S, N, An, T, $scope.wilgerservice.display_units_conv_speed);

        $scope.wilgerservice.best_results = results[0];
        $scope.wilgerservice.other_results = results[1];

        // Build pulsed
        build_charts_pulsed($scope.wilgerservice.best_results, A, S, N, T, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_decimals_press);
        build_charts_pulsed($scope.wilgerservice.other_results, A, S, N, T, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_decimals_press);

        $state.go('tab.calc-pulsed-results');

        $scope.wilgerservice.save();
    };

    $scope.calculateDisabled = function () {
        var A = $scope.wilgerservice.target_application_rate;
        var S = $scope.wilgerservice.target_max_sprayer_speed;
        var N = $scope.wilgerservice.nozzle_spacing;
        var An = $scope.wilgerservice.tip_angle == '80' ? 80 : 110;
        var T = $scope.wilgerservice.target_droplet_size;

        if (A>0 && S>0 && N>0) {
            return false;
        } else {
            return true;
        }

    }

    //
    // Radio button groups
    //

    $scope.tip_angle_list = [
        { text: "80°", value: "80" },
        { text: "110°", value: "110" },
    ];

    //
    // Action sheets
    //

    $scope.showTargetApplicationRate = function() {
        showTargetApplicationRate($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_string_rate);
    };


    $scope.showMaxSprayerSpeed = function() {
        showMaxSprayerSpeed($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_string_speed);
    };


    $scope.showNozzleSpacing = function() {
        showNozzleSpacing($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_length, $scope.wilgerservice.display_units_string_length);
    };


    $scope.showTargetDropletSize = function() {
        showTargetDropletSize($scope, $ionicActionSheet);
    };

    // Popups
    $ionicPopover.fromTemplateUrl('templates/info_droplet_size_pulsed.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_droplet_size_popover = popover;
    });

    $scope.info_droplet_size = function ($event) {
        $scope.info_droplet_size_popover.show($event);
    };
})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardCalcStandardResultsCtrl', function($scope, $state, $ionicActionSheet, $ionicPopover, $ionicModal, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.visible = [];

    $scope.vmd_to_css = function (vmd) {
        return vmd_to_css(vmd);
    };

    $scope.toggleCalcTipShown = function(tip) {
        if ($scope.isCalcTipShown(tip)) {
            $scope.visible = $scope.visible.filter(function (el) { return el !== tip; });
        } else {
            $scope.visible.push(tip);
        }
    };

    $scope.isCalcTipShown = function(tip) {
        return $scope.visible.indexOf(tip) != -1
    };


    $scope.toggleTipFavorite = function(tip) {
        $scope.wilgerservice.toggleTipFavorite(tip);
    };

    $scope.isTipFavorite = function(tip) {
        return $scope.wilgerservice.isTipFavorite(tip);
    };

    // Popups
    $ionicPopover.fromTemplateUrl('templates/info_best_match.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_best_match_popover = popover;
    });

    $scope.info_best_match = function ($event) {
        $scope.info_best_match_popover.show($event);
    };

    $ionicPopover.fromTemplateUrl('templates/info_other_matches.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_other_matches_popover = popover;
    });

    $scope.info_other_matches = function ($event) {
        $scope.info_other_matches_popover.show($event);
    };

    //
    // Legend
    //

    $ionicModal.fromTemplateUrl('templates/info_legend.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.info_legend = modal;
    });
    $scope.openLegend = function() {
      $scope.info_legend.show();
    };
    $scope.closeLegend = function() {
      $scope.info_legend.hide();
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardCalcPulsedResultsCtrl', function($scope, $state, $ionicActionSheet, $ionicPopover, $ionicModal, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.visible = [];

    $scope.vmd_to_css = function (vmd) {
        return vmd_to_css(vmd);
    };

    $scope.toggleCalcTipShown = function(tip) {
        if ($scope.isCalcTipShown(tip)) {
            $scope.visible = $scope.visible.filter(function (el) { return el !== tip; });
        } else {
            $scope.visible.push(tip);
        }
    };

    $scope.isCalcTipShown = function(tip) {
        return $scope.visible.indexOf(tip) != -1
    };


    $scope.toggleTipFavorite = function(tip) {
        $scope.wilgerservice.toggleTipFavorite(tip);
    };

    $scope.isTipFavorite = function(tip) {
        return $scope.wilgerservice.isTipFavorite(tip);
    };

    // Popups
    $ionicPopover.fromTemplateUrl('templates/info_best_match.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_best_match_popover = popover;
    });

    $scope.info_best_match = function ($event) {
        $scope.info_best_match_popover.show($event);
    };

    //
    // Legend
    //

    $ionicModal.fromTemplateUrl('templates/info_legend.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.info_legend = modal;
    });
    $scope.openLegend = function() {
      $scope.info_legend.show();
    };
    $scope.closeLegend = function() {
      $scope.info_legend.hide();
    };
})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardSpecificStandardCtrl', function($scope, $state, $ionicActionSheet, $ionicPopover, WilgerService) {
    $scope.wilgerservice = WilgerService;

    //
    // Calculate
    //

    $scope.calculatePressed = function () {

        var A = $scope.wilgerservice.target_application_rate * 1.0/$scope.wilgerservice.display_units_conv_rate;
        var S = $scope.wilgerservice.target_average_sprayer_speed * 1.0/$scope.wilgerservice.display_units_conv_speed;
        var N = $scope.wilgerservice.nozzle_spacing * 1.0/$scope.wilgerservice.display_units_conv_length;
        // var An = $scope.wilgerservice.tip_angle == '80' ? 80 : 110;
        // var T = $scope.wilgerservice.target_droplet_size;

        var results = get_specific_tips ($scope.wilgerservice.tip_select);

        $scope.wilgerservice.best_results = results[0];
        $scope.wilgerservice.other_results = results[1];

        // Build standard
        build_charts_specific_standard($scope.wilgerservice.best_results, A, S, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_decimals_press);
        build_charts_specific_standard($scope.wilgerservice.other_results, A, S, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_decimals_press);

        $state.go('tab.specific-standard-results');

        $scope.wilgerservice.save();
    };

    $scope.calculateDisabled = function () {
        var TIP = $scope.wilgerservice.tip_select;
        var A = $scope.wilgerservice.target_application_rate;
        var S = $scope.wilgerservice.target_average_sprayer_speed;
        var N = $scope.wilgerservice.nozzle_spacing;

        if (A>0 && S>0 && N>0 && TIP.length > 0) {
            return false;
        } else {
            return true;
        }

    }

    //
    // Action sheets
    //

    $scope.showTargetApplicationRate = function() {
        showTargetApplicationRate($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_string_rate);
    };

    $scope.showAverageSprayerSpeed = function() {
        showAverageSprayerSpeed($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_string_speed);
    };

    $scope.showNozzleSpacing = function() {
        showNozzleSpacing($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_length, $scope.wilgerservice.display_units_string_length);
    };

    // Popups
    $ionicPopover.fromTemplateUrl('templates/info_tip_number.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_tip_number_popover = popover;
    });

    $scope.info_tip_number = function ($event) {
        $scope.info_tip_number_popover.show($event);
    };

})

.controller('WizardSpecificPulsedCtrl', function($scope, $state, $ionicActionSheet, $ionicPopover, WilgerService) {
    $scope.wilgerservice = WilgerService;

    //
    // Calculate
    //

    $scope.calculatePressed = function () {

        var A1 = $scope.wilgerservice.target_application_rate * 1.0/$scope.wilgerservice.display_units_conv_rate;
        var A2 = $scope.wilgerservice.target_application_rate_2 * 1.0/$scope.wilgerservice.display_units_conv_rate;
//         var S = $scope.wilgerservice.target_max_sprayer_speed * 1.0/$scope.wilgerservice.display_units_conv_speed;
        var N = $scope.wilgerservice.nozzle_spacing * 1.0/$scope.wilgerservice.display_units_conv_length;
        // var An = $scope.wilgerservice.tip_angle == '80' ? 80 : 110;
        // var T = $scope.wilgerservice.target_droplet_size;

        var results = get_specific_tips ($scope.wilgerservice.tip_select);

        $scope.wilgerservice.best_results = results[0];
        $scope.wilgerservice.other_results = results[1];

        // Call correct algorithm
        build_charts_specific_pulsed($scope.wilgerservice.best_results, A1, A2, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_decimals_press);
        build_charts_specific_pulsed($scope.wilgerservice.other_results, A1, A2, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_decimals_press);

        $state.go('tab.specific-pulsed-results');

        $scope.wilgerservice.save();
    };

    $scope.calculateDisabled = function () {
        var TIP = $scope.wilgerservice.tip_select;
        var A1 = $scope.wilgerservice.target_application_rate;
        var A2 = $scope.wilgerservice.target_application_rate_2;
        var N = $scope.wilgerservice.nozzle_spacing;

        if ( (A1>0 || A2>0) && N>0 && TIP.length > 0) {
            return false;
        } else {
            return true;
        }

    }

    //
    // Action sheets
    //

    $scope.showTargetApplicationRate = function() {
        showTargetApplicationRate($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_string_rate);
    };

    $scope.showTargetApplicationRate2 = function() {
        showTargetApplicationRate2($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_string_rate);
    };

    $scope.showNozzleSpacing = function() {
        showNozzleSpacing($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_length, $scope.wilgerservice.display_units_string_length);
    };

    // Popups
    $ionicPopover.fromTemplateUrl('templates/info_tip_number.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_tip_number_popover = popover;
    });

    $scope.info_tip_number = function ($event) {
        $scope.info_tip_number_popover.show($event);
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardSpecificStandardResultsCtrl', function($scope, $state, $ionicActionSheet, $ionicModal, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.visible = [];

    $scope.vmd_to_css = function (vmd) {
        return vmd_to_css(vmd);
    };

    $scope.toggleCalcTipShown = function(tip) {
        if ($scope.isCalcTipShown(tip)) {
            $scope.visible = $scope.visible.filter(function (el) { return el !== tip; });
        } else {
            $scope.visible.push(tip);
        }
    };

    $scope.isCalcTipShown = function(tip) {
        return $scope.visible.indexOf(tip) != -1
    };

    $scope.toggleTipFavorite = function(tip) {
        $scope.wilgerservice.toggleTipFavorite(tip);
    };

    $scope.isTipFavorite = function(tip) {
        return $scope.wilgerservice.isTipFavorite(tip);
    };

    //
    // Legend
    //

    $ionicModal.fromTemplateUrl('templates/info_legend.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.info_legend = modal;
    });
    $scope.openLegend = function() {
      $scope.info_legend.show();
    };
    $scope.closeLegend = function() {
      $scope.info_legend.hide();
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardSpecificPulsedResultsCtrl', function($scope, $state, $ionicActionSheet, $ionicModal, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.visible = [];

    $scope.vmd_to_css = function (vmd) {
        return vmd_to_css(vmd);
    };

    $scope.toggleCalcTipShown = function(tip) {
        if ($scope.isCalcTipShown(tip)) {
            $scope.visible = $scope.visible.filter(function (el) { return el !== tip; });
        } else {
            $scope.visible.push(tip);
        }
    };

    $scope.isCalcTipShown = function(tip) {
        return $scope.visible.indexOf(tip) != -1
    };

    $scope.toggleTipFavorite = function(tip) {
        $scope.wilgerservice.toggleTipFavorite(tip);
    };

    $scope.isTipFavorite = function(tip) {
        return $scope.wilgerservice.isTipFavorite(tip);
    };

    //
    // Legend
    //

    $ionicModal.fromTemplateUrl('templates/info_legend.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.info_legend = modal;
    });
    $scope.openLegend = function() {
      $scope.info_legend.show();
    };
    $scope.closeLegend = function() {
      $scope.info_legend.hide();
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardFavoritesStandardCtrl', function($scope, $state, $ionicActionSheet, WilgerService) {
    $scope.wilgerservice = WilgerService;

    //
    // Calculate
    //

    $scope.calculatePressed = function () {

        var A = $scope.wilgerservice.target_application_rate * 1.0/$scope.wilgerservice.display_units_conv_rate;
        var S = $scope.wilgerservice.target_average_sprayer_speed * 1.0/$scope.wilgerservice.display_units_conv_speed;
        var N = $scope.wilgerservice.nozzle_spacing * 1.0/$scope.wilgerservice.display_units_conv_length;
        // var An = $scope.wilgerservice.tip_angle == '80' ? 80 : 110;
        // var T = $scope.wilgerservice.target_droplet_size;

        $scope.wilgerservice.best_results = $scope.wilgerservice.favorites;
        $scope.wilgerservice.other_results = [];

        // Build standard
        build_charts_specific_standard($scope.wilgerservice.best_results, A, S, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_decimals_press);
        build_charts_specific_standard($scope.wilgerservice.other_results, A, S, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_decimals_press);

        $state.go('tab.favorites-standard-results');

        $scope.wilgerservice.save();
    };

    $scope.calculateDisabled = function () {
        var A = $scope.wilgerservice.target_application_rate;
        var S = $scope.wilgerservice.target_max_sprayer_speed;
        var N = $scope.wilgerservice.nozzle_spacing;

        if (A>0 && S>0 && N>0) {
            return false;
        } else {
            return true;
        }

    }

    //
    // Action sheets
    //

    $scope.showTargetApplicationRate = function() {
        showTargetApplicationRate($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_string_rate);
    };

    $scope.showAverageSprayerSpeed = function() {
        showAverageSprayerSpeed($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_string_speed);
    };

    $scope.showNozzleSpacing = function() {
        showNozzleSpacing($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_length, $scope.wilgerservice.display_units_string_length);
    };

})

.controller('WizardFavoritesPulsedCtrl', function($scope, $state, $ionicActionSheet, WilgerService) {
    $scope.wilgerservice = WilgerService;

    //
    // Calculate
    //

    $scope.calculatePressed = function () {

        var A1 = $scope.wilgerservice.target_application_rate * 1.0/$scope.wilgerservice.display_units_conv_rate;
        var A2 = $scope.wilgerservice.target_application_rate_2 * 1.0/$scope.wilgerservice.display_units_conv_rate;
        //var S = $scope.wilgerservice.target_max_sprayer_speed * 1.0/$scope.wilgerservice.display_units_conv_speed;
        var N = $scope.wilgerservice.nozzle_spacing * 1.0/$scope.wilgerservice.display_units_conv_length;
        // var An = $scope.wilgerservice.tip_angle == '80' ? 80 : 110;
        // var T = $scope.wilgerservice.target_droplet_size;

        $scope.wilgerservice.best_results = $scope.wilgerservice.favorites;
        $scope.wilgerservice.other_results = [];

        // Call correct algorithm
        build_charts_specific_pulsed($scope.wilgerservice.best_results, A1, A2, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_decimals_press);
        build_charts_specific_pulsed($scope.wilgerservice.other_results, A1, A2, N, $scope.wilgerservice.display_units_conv_speed, $scope.wilgerservice.display_units_conv_press, $scope.wilgerservice.display_units_decimals_press);

        $state.go('tab.favorites-pulsed-results');

        $scope.wilgerservice.save();
    };

    $scope.calculateDisabled = function () {
        var A1 = $scope.wilgerservice.target_application_rate;
        var A2 = $scope.wilgerservice.target_application_rate_2;
        var N = $scope.wilgerservice.nozzle_spacing;

        if ( (A1>0 || A2>0) && N>0) {
            return false;
        } else {
            return true;
        }

    }

    //
    // Action sheets
    //

    $scope.showTargetApplicationRate = function() {
        showTargetApplicationRate($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_string_rate);
    };

    $scope.showTargetApplicationRate2 = function() {
        showTargetApplicationRate2($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_rate, $scope.wilgerservice.display_units_string_rate);
    };

    $scope.showNozzleSpacing = function() {
        showNozzleSpacing($scope, $ionicActionSheet, $scope.wilgerservice.display_units_conv_length, $scope.wilgerservice.display_units_string_length);
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardFavoritesStandardResultsCtrl', function($scope, $state, $ionicActionSheet, $ionicModal, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.visible = [];

    $scope.vmd_to_css = function (vmd) {
        return vmd_to_css(vmd);
    };

    $scope.toggleCalcTipShown = function(tip) {
        if ($scope.isCalcTipShown(tip)) {
            $scope.visible = $scope.visible.filter(function (el) { return el !== tip; });
        } else {
            $scope.visible.push(tip);
        }
    };

    $scope.isCalcTipShown = function(tip) {
        return $scope.visible.indexOf(tip) != -1
    };

    $scope.toggleTipFavorite = function(tip) {
        $scope.wilgerservice.toggleTipFavorite(tip);
    };

    $scope.isTipFavorite = function(tip) {
        return $scope.wilgerservice.isTipFavorite(tip);
    };

    //
    // Legend
    //

    $ionicModal.fromTemplateUrl('templates/info_legend.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.info_legend = modal;
    });
    $scope.openLegend = function() {
      $scope.info_legend.show();
    };
    $scope.closeLegend = function() {
      $scope.info_legend.hide();
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('WizardFavoritesPulsedResultsCtrl', function($scope, $state, $ionicActionSheet, $ionicModal, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.visible = [];

    $scope.vmd_to_css = function (vmd) {
        return vmd_to_css(vmd);
    };

    $scope.toggleCalcTipShown = function(tip) {
        if ($scope.isCalcTipShown(tip)) {
            $scope.visible = $scope.visible.filter(function (el) { return el !== tip; });
        } else {
            $scope.visible.push(tip);
        }
    };

    $scope.isCalcTipShown = function(tip) {
        return $scope.visible.indexOf(tip) != -1
    };

    $scope.toggleTipFavorite = function(tip) {
        $scope.wilgerservice.toggleTipFavorite(tip);
    };

    $scope.isTipFavorite = function(tip) {
        return $scope.wilgerservice.isTipFavorite(tip);
    };

    //
    // Legend
    //

    $ionicModal.fromTemplateUrl('templates/info_legend.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.info_legend = modal;
    });
    $scope.openLegend = function() {
      $scope.info_legend.show();
    };
    $scope.closeLegend = function() {
      $scope.info_legend.hide();
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('FertilizerCtrl', function($scope, $state, $ionicActionSheet, $ionicPopover, WilgerService) {
    $scope.wilgerservice = WilgerService;

    switchUnitsFert($scope);

    //
    // Radio button groups
    //

    $scope.application_unit_list = [
        { text: "US Gal/Acre", value: "gpa" },
        { text: "US Gal/1000 sq ft.", value: "gp1k" },
        { text: "Imp Gal/Acre", value: "igpa" },
        { text: "Litres/Hectare", value: "lph" }
    ];

    $scope.onChangeUnit = function (val) {
        switchUnitsFert($scope);
    }

    //
    // Calculate
    //

    $scope.calculatePressed = function () {

        var AA = $scope.wilgerservice.fert_target_application_rate_a * 1.0/$scope.wilgerservice.fert_display_units_conv_rate;
        var AB = $scope.wilgerservice.fert_target_application_rate_b * 1.0/$scope.wilgerservice.fert_display_units_conv_rate;
        var S = $scope.wilgerservice.fert_target_average_sprayer_speed * 1.0/$scope.wilgerservice.fert_display_units_conv_speed;
        var N = $scope.wilgerservice.fert_nozzle_spacing * 1.0/$scope.wilgerservice.fert_display_units_conv_length;
        var C = Math.sqrt($scope.wilgerservice.fert_weight/8.34);

        $scope.wilgerservice.fert_results = get_fertilizer_tips (AA, AB, S, N, C);
        build_charts_fertilizer ($scope.wilgerservice.fert_results, AA, AB, S, N, C, $scope.wilgerservice.fert_display_units_conv_speed, $scope.wilgerservice.fert_display_units_conv_press, $scope.wilgerservice.fert_display_units_decimals_press);

        $state.go('tab.fertilizer-results');

        $scope.wilgerservice.save();
    };

    $scope.calculateDisabled = function () {
        var AA = $scope.wilgerservice.fert_target_application_rate_a;
        var AB = $scope.wilgerservice.fert_target_application_rate_b;
        var S = $scope.wilgerservice.fert_target_average_sprayer_speed;
        var N = $scope.wilgerservice.fert_nozzle_spacing;
        var C = $scope.wilgerservice.fert_weight;

        if (AA>0 && S>0 && N>0 && C>0) {
            return false;
        } else {
            return true;
        }
    }

    // Popups
    $ionicPopover.fromTemplateUrl('templates/info_density.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.info_fertilizer_density_popover = popover;
    });

    $scope.info_fertilizer_density = function ($event) {
        $scope.info_fertilizer_density_popover.show($event);
    };

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('FertilizerResultsCtrl', function($scope, $state, $ionicActionSheet, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.visible = [];

    $scope.toggleFertTipShown = function(tip) {
        if ($scope.isFertTipShown(tip)) {
            $scope.visible = $scope.visible.filter(function (el) { return el !== tip; });
        } else {
            $scope.visible.push(tip);
        }
    };

    $scope.isFertTipShown = function(tip) {
        return $scope.visible.indexOf(tip) != -1
    };
})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('FavoritesCtrl', function($scope, $state, $ionicActionSheet, WilgerService) {
    $scope.wilgerservice = WilgerService;

    $scope.visible = [];

    $scope.toggleCalcTipShown = function(tip) {
        if ($scope.isCalcTipShown(tip)) {
            $scope.visible = $scope.visible.filter(function (el) { return el !== tip; });
        } else {
            $scope.visible.push(tip);
        }
    };

    $scope.isCalcTipShown = function(tip) {
        return $scope.visible.indexOf(tip) != -1
    };

    $scope.toggleTipFavorite = function(tip) {
        $scope.wilgerservice.toggleTipFavorite(tip);
    };

    $scope.isTipFavorite = function(tip) {
        return $scope.wilgerservice.isTipFavorite(tip);
    };
})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------

.controller('ContactCtrl', function($scope) {

})

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------
