var module = angular.module('wilger.services', [])

module.service('WilgerService', function(){

    // Copy tips array
    this.tips = tips;

    // Favorites list
    this.favorites = [];

    // Derived results
    this.best_results = [];
    this.other_results = [];

    this.display_units_string_rate = "";
    this.display_units_string_rate_short_1 = "";
    this.display_units_string_rate_short_2 = "";
    this.display_units_conv_rate = 0.0;

    this.display_units_string_press = "";
    this.display_units_conv_press = 0.0;
    this.display_units_decimals_press = 0;

    this.display_units_string_speed = "";
    this.display_units_conv_speed = 0.0;

    this.display_units_string_length = "";
    this.display_units_conv_length = 0.0;

    this.fert_target_application_rate_a = "";
    this.fert_target_application_rate_b = "";
    this.fert_target_average_sprayer_speed = "";
    this.fert_nozzle_spacing = "";
    this.fert_weight = 8.34;

    this.fert_display_units_string_rate = "";
    this.fert_display_units_string_rate_short_1 = "";
    this.fert_display_units_string_rate_short_2 = "";
    this.fert_display_units_conv_rate = 0.0;

    this.fert_display_units_string_press = "";
    this.fert_display_units_conv_press = 0.0;
    this.fert_display_units_decimals_press = 0;

    this.fert_display_units_string_speed = "";
    this.fert_display_units_conv_speed = 0.0;

    this.fert_display_units_string_length = "";
    this.fert_display_units_conv_length = 0.0;

    this.toggleTipFavorite = function(tip) {
        if (this.isTipFavorite(tip)) {
            this.favorites = this.favorites.filter(function (el) { return el !== tip; });
        } else {
            this.favorites.push(tip);
        }

        this.save();
    };

    this.isTipFavorite = function(tip) {
        return this.favorites.indexOf(tip) != -1
    };


    //
    // Save/Load
    //

    this.save = function() {
        try {
            window.localStorage['application_unit']             = this.application_unit;
            window.localStorage['fert_application_unit']        = this.fert_application_unit;
            window.localStorage['spray_system']                 = this.spray_system;
            window.localStorage['search_function']              = this.search_function;
            window.localStorage['tip_angle']                    = this.tip_angle;
            window.localStorage['target_application_rate']      = this.target_application_rate;
            window.localStorage['target_application_rate_2']    = this.target_application_rate_2;
            window.localStorage['target_average_sprayer_speed'] = this.target_average_sprayer_speed;
            window.localStorage['target_max_sprayer_speed']     = this.target_max_sprayer_speed;
            window.localStorage['nozzle_spacing']               = this.nozzle_spacing;
            window.localStorage['target_droplet_size']          = this.target_droplet_size;
            window.localStorage['tip_select']                   = this.tip_select;

            window.localStorage['fert_target_application_rate_a']       = this.fert_target_application_rate_a;
            window.localStorage['fert_target_application_rate_b']       = this.fert_target_application_rate_b;
            window.localStorage['fert_target_average_sprayer_speed']    = this.fert_target_average_sprayer_speed;
            window.localStorage['fert_nozzle_spacing']                  = this.fert_nozzle_spacing;
            window.localStorage['fert_weight']                  = this.fert_weight;

            // Build favorites list
            var savetips = [];
            for (var i = 0; i < this.favorites.length; ++i) {
                savetips.push(this.favorites[i]["tip"]);
            }

            window.localStorage['favorites'] = JSON.stringify(savetips);
        }
        catch(err) {

        }
    };

    this.load = function() {
        try {
            this.application_unit = window.localStorage['application_unit'] || 'gpa';
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.fert_application_unit = window.localStorage['fert_application_unit'] || 'gpa';
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.spray_system = window.localStorage['spray_system'] || 'sss';
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.search_function = window.localStorage['search_function'] || 'search_spray';
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.tip_angle = window.localStorage['tip_angle'] || "80";
            if (this.tip_angle) {
                this.tip_angle = parseInt(this.tip_angle);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.target_application_rate = window.localStorage['target_application_rate'] || null;
            if (this.target_application_rate) {
                this.target_application_rate = parseFloat(this.target_application_rate);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.target_application_rate_2 = window.localStorage['target_application_rate_2'] || null;
            if (this.target_application_rate_2) {
                this.target_application_rate_2 = parseFloat(this.target_application_rate_2);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.target_average_sprayer_speed = window.localStorage['target_average_sprayer_speed'] || null;
            if (this.target_average_sprayer_speed) {
                this.target_average_sprayer_speed = parseFloat(this.target_average_sprayer_speed);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.target_max_sprayer_speed = window.localStorage['target_max_sprayer_speed'] || null;
            if (this.target_max_sprayer_speed) {
                this.target_max_sprayer_speed = parseFloat(this.target_max_sprayer_speed);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.nozzle_spacing = window.localStorage['nozzle_spacing'] || null;
            if (this.nozzle_spacing) {
                this.nozzle_spacing = parseFloat(this.nozzle_spacing);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.target_droplet_size = window.localStorage['target_droplet_size'] || null;
            if (this.target_droplet_size) {
                this.target_droplet_size = parseFloat(this.target_droplet_size);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.tip_select = window.localStorage['tip_select'] || tips[0];
        }
        catch (err) {
            // Ignore errors
        }

        try {
            // Load favorites list
            this.favorites = [];

            var savetips = window.localStorage['favorites'] || null;
            if (savetips) {
                var savetips = JSON.parse(savetips);

                for (var i = 0; i < savetips.length; ++i) {
                    for (var j = 0; j < tips_table.length; ++j) {
                        if (tips_table[j]["tip"] == savetips[i]) {
                            this.favorites.push(tips_table[j]);
                            break;
                        }
                    }
                }
            }
        }
        catch (err) {
            // Ignore errors
        }



        try {
            this.fert_target_application_rate_a = window.localStorage['fert_target_application_rate_a'] || null;
            if (this.fert_target_application_rate_a) {
                this.fert_target_application_rate_a = parseFloat(this.fert_target_application_rate_a);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.fert_target_application_rate_b = window.localStorage['fert_target_application_rate_b'] || null;
            if (this.fert_target_application_rate_b) {
                this.fert_target_application_rate_b = parseFloat(this.fert_target_application_rate_b);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.fert_target_average_sprayer_speed = window.localStorage['fert_target_average_sprayer_speed'] || null;
            if (this.fert_target_average_sprayer_speed) {
                this.fert_target_average_sprayer_speed = parseFloat(this.fert_target_average_sprayer_speed);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.fert_nozzle_spacing = window.localStorage['fert_nozzle_spacing'] || null;
            if (this.fert_nozzle_spacing) {
                this.fert_nozzle_spacing = parseFloat(this.fert_nozzle_spacing);
            }
        }
        catch (err) {
            // Ignore errors
        }

        try {
            this.fert_weight = window.localStorage['fert_weight'] || "10.0";
            if (this.fert_weight) {
                this.fert_weight = parseFloat(this.fert_weight);
            }
        }
        catch (err) {
            // Ignore errors
        }

    };

    // Load from local storage
    this.load();

});
